//Anonynews written by RG Jones
import java.lang.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

public class anonynews extends JFrame
{
private Buttons myButtons;
private Messages myMessages;
private TextArea myViewer;
private JPanel p;

public anonynews()
    {
    this.setTitle("AnonyNews");
    //add stuff we need
    myViewer=new TextArea("",12,80,TextArea.SCROLLBARS_VERTICAL_ONLY);
    myMessages=new Messages(myViewer);
    myButtons=new Buttons(myMessages);
    //configure the view window
    myViewer.setEditable(false);
    Font f=new Font("SansSerif",Font.PLAIN,14);
    myViewer.setFont(f);
    //put in the shutdown bit
    addWindowListener(new WindowAdapter(){
        public void windowClosing(WindowEvent w)
            {
            //Write the value of the server to a text file
            String myServer=new String(myButtons.getServer());
//            System.out.println("Saving this: "+myServer+" length="+myServer.length());
            try
                {
                FileWriter outStream=new FileWriter("server");
                try
                    {
                    outStream.write(myServer,0,myServer.length());
                    }
                catch (IOException e)
                    {
                    System.out.println("Failed to write to file");
                    }
                outStream.close();//to flush the data
                }
            catch (IOException e)
                {
                System.out.println("Failed to open/close file 'server'");
                }
            System.exit(0);
            }
        });
    //put the bits into the panel
    Container c=getContentPane();
    p=new JPanel();
    GridBagLayout grid=new GridBagLayout();
    p.setLayout(grid);
    GridBagConstraints gbc=new GridBagConstraints();
    gbc.anchor=GridBagConstraints.NORTHWEST;
	gbc.weighty=1.0;
    gbc.insets=new Insets(1,1,1,1);//number of pixels between things
    gblAdd(myButtons,grid,gbc,0,0,1,2);
    gblAdd(myMessages,grid,gbc,1,0,3,2);
    gbc.anchor=GridBagConstraints.NORTH;
    gblAdd(myViewer,grid,gbc,0,2,4,2);
    //put the panel into the Content Pane
    c.add("North",p);
    }
   
//create the subroutine to add to the layout
private void gblAdd(Component c,GridBagLayout grid,GridBagConstraints gbc,
                    int x,int y, int w, int h)
    {
    gbc.gridx=x;
    gbc.gridy=y;
    gbc.gridwidth=w;
    gbc.gridheight=h;
    grid.setConstraints(c,gbc);
    p.add(c);
    }

//main program startup
public static void main(String[] args)
    {
    JFrame f= new anonynews();
    f.setSize(600,600);
    f.pack();
    f.show();
    }
}


//The Buttons class will do the work (mostly)
//It has access to the Messages class so it can add Messages to it,
//and so it can get the data required to reply to a message
//It will need the message name, thread, parent and title.
class Buttons extends Panel implements ActionListener
{
private JButton newB,replyB,getHeadersB;
private Panel p;
private Messages myMessage;
private FileReader inStream;
private String myServer;
private JLabel serverLabel,buttonLabel;
private JTextField theServer;

public Buttons(Messages m)
    {
    try
    	{
    	char[] inChars=new char[50];
    	inStream=new FileReader("server");
    	myServer=new String();
    	try
    		{
    		int i=inStream.read(inChars);
    		if (i >0)
    			{
    			//copy up to 50 characters into the string
	    		myServer=myServer.copyValueOf(inChars,0,i);
	    		}
	    	else
	    		{
	    		myServer=new String("localhost");
	    		}
                inStream.close();
    		}
    	catch(IOException  error)
    		{
    		System.out.println("Error reading from or closing file");
	    	myServer=new String("localhost");
    		}
    	}
    catch (FileNotFoundException error)
    	{
    	System.out.println("File: server not found");
    	myServer=new String("localhost");
    	}
//    System.out.println("Default Server= "+myServer);

    myMessage=m;//gives a link to the messages screen
    //set up the visible bits
    buttonLabel=new JLabel("Command Buttons:");
    serverLabel=new JLabel("Server Address:");
    theServer=new JTextField(15);
    theServer.setText(myServer);
    newB=new JButton("New");
    replyB=new JButton("Reply");
    getHeadersB=new JButton("Get Headers");
    newB.addActionListener(this);
    replyB.addActionListener(this);
    getHeadersB.addActionListener(this);
    newB.setActionCommand("N");
    replyB.setActionCommand("R");
    getHeadersB.setActionCommand("G");
    //put them into a panel
    p=new Panel();
    GridBagLayout grid=new GridBagLayout();
    p.setLayout(grid);
    GridBagConstraints gbc=new GridBagConstraints();
    gbc.anchor=GridBagConstraints.NORTHWEST;
    gbc.fill=GridBagConstraints.HORIZONTAL;
    gbc.insets=new Insets(1,1,10,1);//number of pixels between things
    gblAdd(buttonLabel,grid,gbc,0,0,5,2);
    gbc.insets=new Insets(1,1,1,1);//number of pixels between things
    gblAdd(newB,grid,gbc,0,2,5,2);
    gblAdd(replyB,grid,gbc,0,4,5,2);
    gbc.insets=new Insets(1,1,10,1);//number of pixels between things
    gblAdd(getHeadersB,grid,gbc,0,6,5,2);
    gblAdd(serverLabel,grid,gbc,0,8,5,2);
    gblAdd(theServer,grid,gbc,0,10,3,1);
    add(p);
    }

//return the value of the server field
public String getServer()
{
return theServer.getText();
}
//create the subroutine to add to the layout
private void gblAdd(Component c,GridBagLayout grid,GridBagConstraints gbc,
                    int x,int y, int w, int h)
    {
    gbc.gridx=x;
    gbc.gridy=y;
    gbc.gridwidth=w;
    gbc.gridheight=h;
    grid.setConstraints(c,gbc);
    p.add(c);
    }

//what to do if a button is pressed
public void actionPerformed(ActionEvent e)
    {
    Socket theSocket;
    BufferedReader in;
    PrintWriter out;
    String temp,buffer;
    Integer myInt;
    Envelope env;
    ANItemHeader header;
    char c= e.getActionCommand().charAt(0);
    
    switch(c)
        {
        case 'N':
            System.out.println("New Button Pressed");
            header=new ANItemHeader();
            env= new Envelope(header,getServer());
            env.setSize(400,500);
            env.setVisible(true);
            break;
        case 'R':
            System.out.println("Reply Button Pressed");
            //get the Item header from Messages
            header=myMessage.getHeader();
            if(header.File.compareTo("zz")!=0)
            	{
            	//it is a message
	        env=new Envelope(header,getServer());
            	}
            else
            	{
            	//it is a thread holder-create a new message
            	env=new Envelope(new ANItemHeader(),getServer());
            	}
            env.setSize(400,500);
            env.setVisible(true);
            break;
        case 'G':
            System.out.println("Get Headers Button Pressed");
            //set the server name for the messages
            myMessage.setServer(getServer());
            //This is where we connect to the server and get the details
            try
            	{
            	theSocket=new Socket(theServer.getText(),19633);
            	in=new BufferedReader(new InputStreamReader(theSocket.getInputStream()));
            	out=new PrintWriter(theSocket.getOutputStream(),true);
            	buffer=in.readLine();
            	out.println("2");//code for getting headers
            	out.flush();//make sure it goes NOW
            	//loop until there is no more data to receive
            	do
            	{
            	//read in the header:filename, title, thread, parent
            	ANItemHeader myItem=new ANItemHeader();
            	myItem.File=in.readLine();
            	myItem.Title=in.readLine();
            	myItem.Thread=in.readLine();
            	myItem.Parent=in.readLine();
            	//send OK to show we got it
//            	System.out.println("Title: "+myItem.Title+"\nFile: "+myItem.File+"\nThread "+myItem.Thread+"\nParent "+myItem.Parent+"\n");
            	out.println("OK\n");
            	out.flush();
//            	System.out.println("OK Sent");
            	myMessage.addMessage(myItem);  //put the message into the list
            	//I hate this next bit-it just delays to give the server time to send the next bit of data.
            	//to be rewritten when I get the time..
            	Date timerDate=new Date();
            	Date testDate;
            	timerDate.setTime(timerDate.getTime()+100);
            	do
            		{
            		testDate=new Date();//very wasteful of memory here
            		}
            	while (testDate.before(timerDate) && !in.ready());//wait up to 100 ms
            	}
            	while (in.ready());
//            	System.out.println("Loop Finished");
            	//end of loop
            	theSocket.close();
            	}
            catch (UnknownHostException err)
            	{
            	System.out.println("Unknown Host:"+err.getMessage());
            	}
            catch (IOException err)
            	{
            	System.out.println("IOException:"+err.getMessage());
            	}
            break;
        default:
            System.out.println("Error somewhere or other!");
            break;
        }
    }
}

//the ANItemHeader class is the format of the message as stored in the server
//It is four strings, each of which can be set directly:
//returns the Title if toString is called on it
class ANItemHeader
{
public String File;
public String Title;
public String Parent;
public String Thread;

//constructors
public ANItemHeader()
    {
    //default values are what will be used to send a "new" message
    File=new String("0");
    Title=new String("0");
    Parent=new String("0");
    Thread=new String("0");
    }
public ANItemHeader(String f,String t,String p, String th)
    {
    File=f;
    Title=t;
    Parent=p;
    Thread=th;
    }
public ANItemHeader(ANItemHeader h)
    {
    File=h.File;
    Title=h.Title;
    Parent=h.Parent;
    Thread=h.Thread;
    }
    
//this is needed so it will work in a tree
public String toString()
    {
    return Title;
    }
}


//The Messages class contains the tree showing the messages in their 
//correct relationship.
//Clicking on a message should download the message into the Viewer
//so it can be read.
//The highlighted message data must be available to the Buttons class
class Messages extends JPanel
{
private Socket theSocket;
private BufferedReader in;
private PrintWriter out;
private String buffer;
private JScrollPane myScroll;
private JTree myTree;
private DefaultTreeModel treeModel;
private TextArea myView;
private DefaultMutableTreeNode treeTop;
private DefaultTreeCellRenderer renderer;
private String myServer;

//note- we can't read messages until the buttons class has set the server-done during GetHeaders
public Messages(TextArea t)
    {
    ANItemHeader a;
    myView=t;//give access to the message viewing area
    buffer=new String();
    myServer=new String("localhost");
    
    //do the tree
    treeTop=new DefaultMutableTreeNode("Messages");
    treeModel=new DefaultTreeModel(treeTop);
    renderer=new DefaultTreeCellRenderer();
    renderer.setLeafIcon(new ImageIcon("open.gif"));
    renderer.setClosedIcon(new ImageIcon("closed.gif"));
    renderer.setOpenIcon(new ImageIcon("open.gif"));
    myTree=new JTree(treeModel);
    myTree.setEditable(false);
    myTree.setCellRenderer(renderer);
    myTree.putClientProperty("JTree.lineStyle","Angled");
    myTree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    myTree.addTreeSelectionListener(new TreeSelectionListener()
        {
        public void valueChanged(TreeSelectionEvent e)
            {
            DefaultMutableTreeNode node= (DefaultMutableTreeNode)myTree.getLastSelectedPathComponent();
            //make sure we have a valid node
            if ((node == null) || (node == treeTop)) return;
            //expand the node if it isn't already
            if (myTree.isCollapsed(myTree.getSelectionPath()))
            	{
            	myTree.expandPath(myTree.getSelectionPath());
            	}
            //if it's not a message, don't try to retrieve it
            ANItemHeader nodeInfo= (ANItemHeader)node.getUserObject();
            if(nodeInfo.File.compareTo("zz")==0)
            	{
            	myView.setText("This is a Thread Holder\nMessages are stored below it");
            	return;
            	}
            //read the message here
            myView.setText("");
//            System.out.println("Server="+myServer);
           try
            	{
            	theSocket=new Socket(myServer,19633);
//            	System.out.println("Connection made on Socket:"+theSocket.toString());
            	in=new BufferedReader(new InputStreamReader(theSocket.getInputStream()));
//            	System.out.println("In stream connected");
            	out=new PrintWriter(theSocket.getOutputStream(),true);
//            	System.out.println("OutStreamConnected");
            	buffer=in.readLine();
//            	System.out.println("Received:"+buffer);
            	out.println("3");//code for getting headers
            	out.flush();//make sure it goes NOW
            	buffer=in.readLine();
//            	System.out.println("Received:"+buffer);
            	out.println(nodeInfo.File);//send which file to read
            	out.flush();//send it NOW
            	buffer=in.readLine();//this is the title of the message
            	out.println("OK");
            	out.flush();//send it NOW
            	do
            		{
//            		System.out.println("Reading data");
            		buffer=in.readLine();
            		if (buffer!=null)
            			{
	            		myView.append(buffer);
	            		myView.append("\n");
            			}
            		}
            	while (in.ready());
            	theSocket.close();
            	}
            catch (UnknownHostException err)
            	{
            	System.out.println("Unknown Host:"+err.getMessage());
            	}
            catch (IOException err)
            	{
            	System.out.println("IOException:"+err.getMessage());
            	}
            }
        });
    
    //sort out the scroll pane for the tree to fit into
    myScroll=new JScrollPane(myTree);
    myScroll.setPreferredSize(new Dimension(395,300));
    myScroll.setMinimumSize(new Dimension(300,200));
    add(myScroll);    
    }

//set the name of the server
public void setServer(String s)
{
	myServer=s;
}
//add message headers to the display
public void addMessage(ANItemHeader a)
    {
	ANItemHeader h, threadHeader;
	DefaultMutableTreeNode testNode,parentNode,threadNode;
	boolean threadFound=false,parentFound=false,selfFound=false;
	
	//set the parent and thread nodes to the top just in case they don't get initialised properly
	parentNode=treeTop;
	threadNode=treeTop;
	//put the new message into the tree structure
	testNode=treeTop.getNextNode();//Start at the first node in the tree
	while ((testNode!=null) && (!threadFound))
		{
		h=(ANItemHeader)testNode.getUserObject();
		if (h.Thread.compareTo(a.Thread)==0)//are we in the right thread yet?
			{
			//the first item in the thread is the header
			threadFound=true;
			threadNode=testNode;
			threadHeader=(ANItemHeader)testNode.getUserObject();
			//now look at the messages in the thread
			testNode=testNode.getNextNode();//not the most efficient way, but it'll do
			h=(ANItemHeader)testNode.getUserObject();
			//keep looking until the next thing is not in this thread
			while ((testNode!=null)  && (h.Thread.compareTo(threadHeader.Thread)==0) && (!selfFound))
				{
				if (!parentFound)
					{
					if (a.Parent.compareTo(h.File)==0)
						{
						parentFound=true;
						parentNode=testNode;
						}
					}
				if (!selfFound)
					{
					if (a.File.compareTo(h.File)==0)
						{
						selfFound=true;
						}
					}
				//get the next node and its header
				testNode=testNode.getNextNode();
				if (testNode!=null)
					h=(ANItemHeader)testNode.getUserObject();
				}
			}
		if(testNode!=null)//this could be null if the previous get next node was at the end of the tree
			testNode=testNode.getNextSibling();//go to the next thread
		}
	
	//finished traversing the tree
	//if the message has notbeen found, insert it in the proper place
	if(!selfFound)
	{
	if(parentFound)
		{
		treeModel.insertNodeInto(new DefaultMutableTreeNode(a),parentNode,parentNode.getChildCount());
		}
	else
		{
		if(threadFound)
			{
			//put it into the thread holder
			treeModel.insertNodeInto(new DefaultMutableTreeNode(a),threadNode,threadNode.getChildCount());
			}
		else
			{
			//create a thread holder and put it in there
			DefaultMutableTreeNode t=new DefaultMutableTreeNode(new ANItemHeader("zz",a.Title,"zz",a.Thread));
			treeModel.insertNodeInto(t,treeTop,treeTop.getChildCount());
			treeModel.insertNodeInto(new DefaultMutableTreeNode(a),t,t.getChildCount());
			}
		}
	}
	//update the tree display
	treeModel.reload();
	
	
    }

//Return the data for the selected message
public ANItemHeader getHeader()
    {
    ANItemHeader nodeInfo;
    
    DefaultMutableTreeNode node= (DefaultMutableTreeNode)myTree.getLastSelectedPathComponent();
            
    if ((node == null) || (node == treeTop))
        {
        nodeInfo=new ANItemHeader();
        }
    else
        {           
        nodeInfo= (ANItemHeader)node.getUserObject();
        }
    
    return nodeInfo;
    }
}

//The envelope class is for writing messages.
//It takes an Item Header to give it the info as to what
//data to send to the server
class Envelope extends JFrame implements ActionListener
{
private JLabel t1,m1;
private TextField title;
private TextArea message;
private ANItemHeader h;
private JButton send,cancel;
private JPanel p,p1;
private String theServer;

public Envelope(ANItemHeader header,String sString)
    {
    this.setTitle("Message Writer");
    this.setLocation(10,10);
    h=new ANItemHeader(header);//take a copy so multiple windows can be open
    theServer=new String(sString);
    Container c=getContentPane();
    t1=new JLabel("Message Title");
    m1=new JLabel("Message Body");
    title=new TextField(40);
    if (h.Title.compareTo("0")==0)
    	{
    	//this is a new message
    	title.setText("");
    	}
    else
    	{
    	if(h.Title.startsWith("RE:"))
	        {
	        title.setText(h.Title);
	        }
	else
	        {
	        String temp=new String("RE: ");
	        temp=temp.concat(h.Title);
	        title.setText(temp);
	        }
        }
    message=new TextArea("",20,40,TextArea.SCROLLBARS_VERTICAL_ONLY);
    send=new JButton("Send");
    send.addActionListener(this);
    cancel=new JButton("Cancel");
    cancel.addActionListener(this);
    p=new JPanel();
    p1=new JPanel();
    p.add(t1);
    p.add(title);
    p.add(m1);
    p.add(message);
    p1.add(send);
    p1.add(cancel);
    c.add("North",p);
    c.add("South",p1);
    pack();
    show();
    }

public void actionPerformed(ActionEvent e)
    {
    Socket theSocket;
    BufferedReader in;
    PrintWriter out;
    String buffer;
    char c=e.getActionCommand().charAt(0);
    switch(c)
        {
        case 'S':
        	//check the length of the title and message, as zero length strings will cause chaos
        	if ((title.getText().length()==0) || (message.getText().length()==0))
        		{
        		System.out.println("You must input a title AND message!\n");
        		}
        	else
        		{	
		        //send the message now
		        try
	              	{
	              	theSocket=new Socket(theServer,19633);
	              	in=new BufferedReader(new InputStreamReader(theSocket.getInputStream()));
	              	out=new PrintWriter(theSocket.getOutputStream(),true);
	              	buffer=in.readLine();
	              	out.println("1");//code for sending message
	              	out.flush();//make sure it goes NOW
	              	buffer=in.readLine();//read an OK
			out.println(title.getText());//sends the Title
			out.flush();
			buffer=in.readLine();//read an OK
			out.println(h.Thread);//sends the Thread it belongs to
			out.flush();
			buffer=in.readLine();//read an OK
			out.println(h.File);//sends the Parent of this message
			out.flush();
			buffer=in.readLine();//read an OK
			out.println(message.getText());
			out.flush();
			out.close();
//			System.out.println("Sent: \nThread "+h.Thread+"\nParent "+h.File+"\n");
            		}
                catch (UnknownHostException err)
	            	{
		        System.out.println("Unknown Host:"+err.getMessage());
	            	}
	        catch (IOException err)
	            	{
	            	System.out.println("IOException:"+err.getMessage());
	            	}
                        }
            break;
        case 'C':
            //don't do anything
            break;
        default:
            break;
        }
    dispose();    
    }
}